farmlands = {};
farmlands.sortBy = "FarmId";

--needs module not
--lineType max 3/farmlands
function farmlands.load()
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {txtScroll={leftRight=true,upDown=true}};
	for farmlandId, farm in pairs (g_farmlandManager.farmlands) do				
		lineTable[#lineTable+1] = {};
		local isLineTable = lineTable[#lineTable];
		isLineTable.farmlandid = Utils.getNoNil(farm.id, 0);
		isLineTable.farmid = 0;
		isLineTable.ownValues = {farm};
		local isFarmId = false;
		if g_farmlandManager:getFarmlandOwner(farm.id) == playerFarmId then isLineTable.farmid = playerFarmId;isFarmId=true;end;
		isLineTable.price = Utils.getNoNil(farm.price, 0);
		isLineTable.hectar = Utils.getNoNil(farm.areaInHa, 0);
		local leasedTxt = "";
		if farm.isLeased ~= nil and farm.isLeased then leasedTxt = "L# ";end;
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].width = 35;
		isLineTable.txt[1].txt = "Farmland ".. tostring(farm.id);
		isLineTable.txt[1].color = moSetGetExtras:getColorForFarm(isLineTable.farmid);
		isLineTable.txt[1].clickCallback = farmlands.returnClickFarmland;		
		isLineTable.txt[2] = {};
		isLineTable.txt[2].width = 25;
		isLineTable.txt[2].txt = tostring(string.format("%1.2f", "".. tostring(farm.areaInHa))).. " ha";
		isLineTable.txt[2].color = moSetGetExtras:getColorForFarm(isLineTable.farmid);
		isLineTable.txt[2].txtPos = 1;
		isLineTable.txt[3] = {};
		isLineTable.txt[3].width = 40;
		isLineTable.txt[3].txt = leasedTxt.. g_i18n:formatMoney(farm.price);		
		isLineTable.txt[3].color = moSetGetExtras:getColorForFarm(isLineTable.farmid);
		if farm.isOwned and not isFarmId then isLineTable.txt[3].txt = "-";end;
		if not farm.isOwned then
			local playerFarm = g_farmManager:getFarmById(playerFarmId)
			if playerFarm.money < farm.price then isLineTable.txt[3].color = moColors:getColor("darkGray");end;
		end;		
		isLineTable.txt[3].txtPos = 2;
	end;
	function comp(w1,w2)		
		if w1[farmlands.sortBy:lower()] > w2[farmlands.sortBy:lower()] then
			return true;
		end;				
	end;
	table.sort(lineTable, comp);	
	function setFirstLine()
		table.insert(lineTable, 1, {});		
		local isLineTable = lineTable[1];
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = farmlands.returnLineHelpIconClick;
		isLineTable.helpTxt = "Click Farmland (MapHotSpot)\nClick Sort By ... for SortType";
		isLineTable.txt = {};
		isLineTable.txt[1] = {color=moColors:getColor(moModule.values.txtTitleColor), txtPos=1, txt="Farmlands", bold=true};
		table.insert(lineTable, 2, {});
		isLineTable = lineTable[2];		
		isLineTable.txt = {};
		isLineTable.txt[1] = {clickCallback=farmlands.returnLineSortByClick, color=moColors:getColor(moModule.values.txtTitleColor), txtPos=0, txt="Sort By ".. tostring(farmlands.sortBy), bold=true};
		isLineTable.txt[1].settingsButtonL = {"buttonLeft", moColors.intern["green"], farmlands.returnLineSortByClick};
	end;
	setFirstLine();
	farmlands.output = lineTable;
end;

function farmlands.returnClickFarmland(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local farmland = farmlands.output[args.line].ownValues[1];
			local x = farmland.xWorldPos;
			local z = farmland.zWorldPos;
			if x ~= nil and x ~= 0 then
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;		
		end;		
	end;
end;

function farmlands.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(farmlands.output[args.line].helpTxt);
		end;
	end;
end;

function farmlands.returnLineSortByClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if farmlands.sortBy == "FarmId" then
			farmlands.sortBy = "Hectar";
		elseif farmlands.sortBy == "Hectar" then
			farmlands.sortBy = "Price";
		elseif farmlands.sortBy == "Price" then
			farmlands.sortBy = "FarmlandId";
		elseif farmlands.sortBy == "FarmlandId" then
			farmlands.sortBy = "FarmId";
		end;
	end;
end;

function farmlands.giveOutputTable()	
	farmlands:load();
	return farmlands.output;	
end;

function farmlands:reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	farmlands:load();
end;

function farmlands:generateCmd()
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "farmlands";
		displayName = "Farmlands";		
		multiple = true;
		sortBy = "Module by Moh";
		infoTxt = "Zeigt alle Farmlands an";
		helpTxt = "Farmlands List";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		lineTyp = 2;
		typ = "output";
		action = farmlands.giveOutputTable; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate farmlands Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
end;